diff -urNb aodv-uu-0.7.2/maodv_ext.h maodv-umd-0.7.2/maodv_ext.h
--- aodv-uu-0.7.2/maodv_ext.h	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/maodv_ext.h	Wed Jun 25 17:46:09 2003
@@ -0,0 +1,98 @@
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Dionysus Blazakis <dblaze@umd.edu>
+ *          Jonathan Polley <jpolley@umd.edu>
+ *          Dan Rusk <drusk@umd.edu>
+ *          Manish Karir <karir@umd.edu>
+ *
+ *****************************************************************************/
+
+#ifndef MAODV_EXT_H
+#define MAODV_EXT_H
+
+#ifndef NS_NO_GLOBALS
+#include <endian.h>
+
+#include "defs.h"
+
+typedef struct _grp_leader_ext_t {
+    u_int8_t type;
+    u_int8_t length;
+    u_int32_t grp_leader_addr;
+    u_int32_t prev_hop_addr;
+} grp_leader_ext;
+
+typedef struct _grp_rebuild_ext_t {
+    u_int8_t type;
+    u_int8_t length;
+    u_int16_t grp_hcnt;
+} grp_rebuild_ext;
+
+typedef struct _grp_info_ext_t {
+    u_int8_t type;
+    u_int8_t length;
+    u_int32_t grp_hcnt;
+    u_int32_t grp_leader_addr;
+} grp_info_ext;
+
+/* See note below. */
+typedef struct _grp_merge_ext_t {
+    u_int8_t type;
+    u_int8_t length;
+    u_int16_t res;
+    u_int32_t grp_addr;
+    u_int32_t grp_seqno;
+} grp_merge_ext;
+
+#define GRP_LEADER_EXT        (grp_leader_ext)
+#define GRP_LEADER_EXT_SIZE   ( sizeof(GRP_LEADER_EXT) )
+#define GLE_TYPE              ( 3 )
+                              /* 2 = size of header */
+#define GLE_LENGTH            (GRP_LEADER_EXT_SIZE - 2)  
+
+#define GRP_REBUILD_EXT       grp_rebuild_ext
+#define GRP_REBUILD_EXT_SIZE  ( sizeof(GRP_REBUILD_EXT) )
+#define GRE_TYPE              ( 4 )
+                              /* 2 = size of header */
+#define GRE_LENGTH            (GRP_REBUILD_EXT_SIZE - 2)
+
+#define GRP_INFO_EXT          (grp_info_ext)
+#define GRP_INFO_EXT_SIZE     ( sizeof(GRP_INFO_EXT) )
+#define GIE_TYPE              ( 5 )
+                              /* 2 = size of header */
+#define GIE_LENGTH            (GRP_INFO_EXT_SIZE - 2)
+
+/* NOTE: This is a non-standard extension.  The draft is
+   unclear about the tree merge process.  We have created
+   a new extension for our tree merge.  The type number
+   was chosen in an attempt to avoid collisions with any
+   future extensions. */
+#define GRP_MERGE_EXT         grp_merge_ext
+#define GRP_MERGE_EXT_SIZE    ( sizeof(GRP_MERGE_EXT) )
+#define GME_TYPE              ( 9 )
+                              /* 2 = size of header */
+#define GME_LENGTH            (GRP_MERGE_EXT_SIZE - 2)
+
+#endif				/* NS_NO_GLOBALS */
+
+#ifndef NS_NO_DECLARATIONS
+
+#endif				/* NS_NO_DECLARATIONS */
+
+#endif				/* MAODV_MACT_H */
diff -urNb aodv-uu-0.7.2/maodv_grph.c maodv-umd-0.7.2/maodv_grph.c
--- aodv-uu-0.7.2/maodv_grph.c	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/maodv_grph.c	Mon Jun 30 13:53:47 2003
@@ -0,0 +1,226 @@
+#ifdef MAODV
+
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Dionysus Blazakis <dblaze@umd.edu>
+ *          Jonathan Polley <jpolley@umd.edu>
+ *          Dan Rusk <drusk@umd.edu>
+ *          Manish Karir <karir@umd.edu>
+ *          Jonathan McGee <mcgee@umd.edu>
+ *
+ *****************************************************************************/
+
+#ifdef NS_PORT
+#include "aodv-uu.h"
+#else
+#include <netinet/in.h>
+#include "maodv_grph.h"
+#include "aodv_socket.h"
+#include "params.h"
+#include "seek_list.h"
+#include "defs.h"
+#include "debug.h"
+#include "multicast_routing_table.h"
+#include "aodv_rreq.h"
+#endif
+
+GRPH *grph_create(u_int8_t flags, u_int8_t hcnt, u_int32_t grp_leader_addr, u_int32_t grp_addr, u_int32_t grp_seqno) 
+{
+    GRPH *grph;
+
+    grph=(GRPH *)aodv_socket_new_msg();
+
+    grph->type=MAODV_GRPH;
+    grph->res1=0;
+    grph->res2=0;
+    grph->hcnt=hcnt;
+    grph->grp_leader_addr=htonl(grp_leader_addr);
+    grph->grp_addr=htonl(grp_addr);
+    grph->grp_seqno=htonl(grp_seqno);
+
+    if(flags & GRPH_UPDATE)
+        grph->u=1;
+    if(flags & GRPH_OFFMTREE)
+        grph->o=1;
+
+    DEBUG(LOG_DEBUG, 0, "Assembled GRPH %s", ip_to_str(grp_addr));
+    if(grph->u){
+        DEBUG(LOG_DEBUG, 0, "GRPH->u set");
+    }
+
+    return grph;
+}
+
+void grph_send(u_int8_t flags, u_int8_t hcnt, u_int32_t grp_addr, u_int32_t grp_seqno) 
+{
+    GRPH *grph;
+    int i;
+    /* ttl is one, packets get rebroadcast at each step */
+    int ttl = NET_DIAMETER;
+
+    for(i=0; i<MAX_NR_INTERFACES; i++) {
+        if (!DEV_NR(i).enabled)
+            continue;
+
+        /* CHECK:  Will things break with different ip's per if for leader? */
+
+        grph=grph_create(flags, hcnt, DEV_NR(i).ipaddr, grp_addr, grp_seqno);
+        aodv_socket_send((AODV_msg *)grph, AODV_BROADCAST, GRPH_SIZE, ttl, &DEV_NR(i));
+    }
+}
+
+void grph_forward(GRPH *grph, int ttl)
+{
+    int i;
+    DEBUG(LOG_DEBUG, 0, "forwarding GRPH about %s", ip_to_str(ntohl(grph->grp_addr)));
+
+    grph = (GRPH *) aodv_socket_queue_msg((AODV_msg *) grph, GRPH_SIZE);
+    grph->hcnt++;
+    for(i=0; i<MAX_NR_INTERFACES; i++) {
+        if (!DEV_NR(i).enabled)
+            continue;
+        aodv_socket_send((AODV_msg *)grph, AODV_BROADCAST, GRPH_SIZE, ttl, &DEV_NR(i));
+    }
+}
+
+/* special forwarding: unicast to your upstream */
+void grph_forward_ucast(mrt_table_t *mrt, GRPH *grph, int ttl)
+{
+    mrt_nexthop_t *upstream;
+    rt_table_t *rt;
+    
+    DEBUG(LOG_DEBUG, 0, "forwarding GRPH about %s upstream",
+            ip_to_str(ntohl(grph->grp_addr)));
+
+    upstream=mrt_table_get_activated_upstream(mrt);
+    if(upstream != NULL){
+        rt=rt_table_find(upstream->addr);
+        grph->hcnt++;
+        grph = (GRPH *) aodv_socket_queue_msg((AODV_msg *) grph, GRPH_SIZE);
+        aodv_socket_send((AODV_msg *)grph, upstream->addr, GRPH_SIZE, ttl, &DEV_IFINDEX(rt->ifindex));
+    }
+}
+
+void grph_process(GRPH *grph, u_int32_t src_addr, int ttl)
+{
+    mrt_table_t *mrt;
+    u_int32_t grp_addr;
+    u_int32_t grp_leader_addr;
+    u_int32_t grp_seqno;
+    int do_forward=0, do_forward_ucast=0;
+    u_int8_t new_hcnt;
+
+    grp_addr=ntohl(grph->grp_addr);
+    grp_leader_addr=ntohl(grph->grp_leader_addr);
+    grp_seqno=ntohl(grph->grp_seqno);
+    new_hcnt=grph->hcnt+1;
+    
+    mrt=mrt_table_find(grp_addr);
+    if(mrt==NULL){
+        mrt=mrt_table_insert(grp_addr, grp_leader_addr, grp_seqno, 0, new_hcnt, 0);
+        do_forward=1;
+    }
+    
+    if(mrt->is_router){
+        mrt_nexthop_t *upstream;
+        upstream=mrt_table_get_activated_upstream(mrt);
+
+        /* group leader doens't need to process grph */
+        /* nor do I care about offmtree packets if I'm on the tree */
+        if(mrt->am_leader){
+            if(mrt->grp_leader_addr != grp_leader_addr){
+                /* initiate tree merge */
+                /* Check IP's */
+                if ( ( mrt->grp_leader_addr < grp_leader_addr ) &&
+                   ( !mrt->in_repair ) ){
+                    /* my IP is less than his ;( */
+                    /* initiate route discovery with all the flags */
+                    DEBUG(LOG_DEBUG, 0, "Initiating tree merge for %s.", ip_to_str(grp_addr));
+
+                    mrt->in_repair = 1;
+                    rreq_route_discovery( grp_leader_addr, 
+                        RREQ_JOIN | RREQ_REPAIR | RREQ_DEST_ONLY,
+                        NULL, mrt->grp_addr );
+                }
+            }
+        }else if(!grph->o){
+            if(upstream != NULL && src_addr==upstream->addr){
+                mrt->leader_hcnt=new_hcnt;
+                mrt->grp_seqno=grp_seqno;
+
+                if(grph->u || mrt->grp_leader_addr!=grp_leader_addr){
+                    mrt_table_set_leader(mrt, grp_leader_addr, new_hcnt);
+                }
+                do_forward=1;
+            }
+        }
+        
+        if(!mrt->am_leader && grp_leader_addr != mrt->grp_leader_addr){
+            /* if you get a grph for a different leader.... */
+            /* unicast it to your upstream */
+            do_forward_ucast=1;
+        }
+    }else{
+        /* if not on the tree, you can be less discriminating about 
+           your information */
+        grph->o=1;
+        /* potential method for forwarding grph */
+        if(grp_seqno>mrt->grp_seqno || 
+          (grp_seqno==mrt->grp_seqno && new_hcnt<mrt->leader_hcnt)){
+            do_forward=1;
+        }
+        if(mrt->grp_leader_addr!=grp_leader_addr ||
+          (mrt->grp_leader_addr==grp_leader_addr && new_hcnt<mrt->leader_hcnt)){
+            mrt_table_set_leader(mrt, grp_leader_addr, new_hcnt);
+            do_forward=1;
+        }
+        /* and finally update our sequence number */
+        mrt->grp_seqno=grp_seqno;
+
+    }
+
+    if(do_forward && ttl>1){
+        grph_forward(grph, --ttl);
+    }
+
+    if(do_forward_ucast && ttl>1){
+        grph_forward_ucast(mrt, grph, --ttl);
+    }
+
+    if(this_host.gateway_mode && !mrt->is_router) {
+        /* In Gateway mode, we want a piece of every group */
+        mrt->is_gateway = 1;
+        rreq_route_discovery( grp_addr, RREQ_JOIN, NULL, 0 );
+    }
+}
+
+void grph_send_callback(mrt_table_t *mrt){
+    int flags=0;
+    if(mrt->grph_update_cnt>0){
+        flags=GRPH_UPDATE;
+        mrt->grph_update_cnt--;
+    }
+    if(mrt->am_leader){
+        grph_send(flags, 0, mrt->grp_addr, ++mrt->grp_seqno);
+    
+        timer_set_timeout(&(mrt->grph_timer), GROUP_HELLO_INTERVAL);
+    }
+}
+
+#endif /* MAODV */
diff -urNb aodv-uu-0.7.2/maodv_grph.h maodv-umd-0.7.2/maodv_grph.h
--- aodv-uu-0.7.2/maodv_grph.h	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/maodv_grph.h	Wed Jun 25 17:46:09 2003
@@ -0,0 +1,84 @@
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Dionysus Blazakis <dblaze@umd.edu>
+ *          Jonathan Polley <jpolley@umd.edu>
+ *          Dan Rusk <drusk@umd.edu>
+ *          Manish Karir <karir@umd.edu>
+ *
+ *****************************************************************************/
+
+#ifndef MAODV_GRPH_H
+#define MAODV_GRPH_H
+
+#ifndef NS_NO_GLOBALS
+#include <endian.h>
+
+#include "defs.h"
+#include "multicast_routing_table.h"
+
+/* GRPH Flags: */
+#define GRPH_UPDATE   0x2
+#define GRPH_OFFMTREE 0x1
+
+typedef struct _grph_t {
+    u_int8_t type;
+#  if __BYTE_ORDER == __LITTLE_ENDIAN
+    u_int8_t res1:6;
+    u_int8_t o:1;
+    u_int8_t u:1;
+#  elif __BYTE_ORDER == __BIG_ENDIAN
+    u_int8_t u:1;
+    u_int8_t o:1;
+    u_int8_t res1:6;
+#  else
+#   error "Adjust your <bits/endian.h> defines"
+#  endif
+    u_int8_t res2;
+    u_int8_t hcnt;
+    u_int32_t grp_leader_addr;
+    u_int32_t grp_addr;
+    u_int32_t grp_seqno;
+} grph_t;
+
+#define GRPH grph_t
+#define GRPH_SIZE sizeof(grph_t)
+
+#endif				/* NS_NO_GLOBALS */
+
+#ifndef NS_NO_DECLARATIONS
+GRPH *grph_create(u_int8_t flags,
+        u_int8_t hcnt,
+        u_int32_t grp_leader_addr,
+        u_int32_t grp_addr,
+        u_int32_t grp_seqno);
+
+void grph_send(u_int8_t flags,
+        u_int8_t hcnt,
+        u_int32_t grp_addr,
+        u_int32_t grp_seqno);
+
+void grph_forward(GRPH * GRPH, int ttl);
+
+void grph_process(GRPH * GRPH, u_int32_t src, int ttl);
+
+void grph_send_callback(mrt_table_t *mrt);
+
+#endif				/* NS_NO_DECLARATIONS */
+
+#endif				/* MAODV_GRPH_H */
diff -urNb aodv-uu-0.7.2/maodv_mact.c maodv-umd-0.7.2/maodv_mact.c
--- aodv-uu-0.7.2/maodv_mact.c	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/maodv_mact.c	Mon Jun 30 13:53:47 2003
@@ -0,0 +1,302 @@
+#ifdef MAODV
+
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Dionysus Blazakis <dblaze@umd.edu>
+ *          Jonathan Polley <jpolley@umd.edu>
+ *          Dan Rusk <drusk@umd.edu>
+ *          Manish Karir <karir@umd.edu>
+ *          Jonathan McGee <mcgee@umd.edu>
+ *
+ *****************************************************************************/
+
+#ifdef NS_PORT
+#include "aodv-uu.h"
+#else
+#include <netinet/in.h>
+#include "maodv_mact.h"
+#include "maodv_grph.h"
+#include "aodv_socket.h"
+#include "params.h"
+#include "seek_list.h"
+#include "defs.h"
+#include "debug.h"
+#include "multicast_routing_table.h"
+#include "packet_queue.h"
+#endif
+
+MACT *mact_create(u_int8_t flags, u_int8_t hcnt, u_int32_t src_addr, 
+    u_int32_t grp_addr)
+{
+    MACT *mact;
+
+    mact=(MACT *)aodv_socket_new_msg();
+
+    mact->type=MAODV_MACT;
+    mact->res1=0;
+    mact->res2=0;
+    mact->hcnt=hcnt;
+    mact->grp_addr=htonl(grp_addr);
+    mact->src_addr=htonl(src_addr);
+    mact->src_seqno=htonl(++this_host.seqno);
+
+    /* handle flags */
+    if(flags & MACT_JOIN)
+        mact->j=1;
+    if(flags & MACT_PRUNE)
+        mact->p=1;
+    if(flags & MACT_GRPL)
+        mact->g=1;
+    if(flags & MACT_UPDATE)
+        mact->u=1;
+    if(flags & MACT_REBOOT)
+        mact->r=1;
+
+    DEBUG(LOG_DEBUG, 0, "Assembled MACT %s", ip_to_str(grp_addr));
+
+    return mact;
+}
+
+void mact_send(u_int8_t flags, u_int8_t hcnt, u_int32_t grp_addr, u_int32_t dst_addr, int ttl)
+{
+    MACT *mact;
+    rt_table_t *route;
+    int i;
+
+    route=rt_table_find(dst_addr);
+    i=route->ifindex;
+    mact=mact_create(flags, hcnt, DEV_IFINDEX(i).ipaddr, grp_addr);
+
+    aodv_socket_send((AODV_msg *)mact, dst_addr, MACT_SIZE, ttl, &DEV_IFINDEX(i));
+}
+
+void mact_mcast(u_int8_t flags, u_int8_t hcnt, u_int32_t grp_addr, int ttl)
+{
+    MACT *mact;
+    mrt_table_t *group_rec;
+    mrt_nexthop_t *nexthop;
+    rt_table_t *route;
+    /* prevent sending packet twice on an iface */
+    static char ifmask[MAX_NR_INTERFACES];
+    int i;
+
+    bzero(ifmask, sizeof(ifmask)*sizeof(char));
+
+    group_rec=mrt_table_find(grp_addr);
+    nexthop=group_rec->nexthops;
+
+    /* an attempt to send multicast packets right.
+     * destination is group address
+     * only send one per interface you are currently multicasting to group on
+     */
+    while(nexthop!=NULL) {
+        route=rt_table_find(nexthop->addr);
+        i=route->ifindex;
+        if (!DEV_IFINDEX(i).enabled)
+            continue;
+        if (!ifmask[i]) {
+            mact=mact_create(flags, hcnt, DEV_IFINDEX(i).ipaddr, grp_addr);
+            aodv_socket_send((AODV_msg *)mact, grp_addr, MACT_SIZE, ttl, &DEV_IFINDEX(i));
+            ifmask[i]=1;
+        }
+        nexthop=nexthop->next;
+    }
+}
+
+void mact_process(MACT *mact)
+{
+    u_int32_t src_addr, grp_addr, src_seqno;
+    u_int8_t hcnt;
+    mrt_table_t *group_rec;
+
+    src_addr=ntohl(mact->src_addr);
+    grp_addr=ntohl(mact->grp_addr);
+    src_seqno=ntohl(mact->src_seqno);
+    hcnt=mact->hcnt;
+
+    group_rec=mrt_table_find(grp_addr);
+
+    if(group_rec == NULL) {
+        /* shouldn't happen */
+        return;
+    }
+
+    if(mact->j) {
+        /* JOIN */
+        /* sender wants to join specified group with us as next hop.
+         * if we are already in group, then fine, else need to
+         * pseudo-join ourselves.
+         */
+        mrt_nexthop_t *nh;
+        
+        nh=mrt_nexthop_find(group_rec, src_addr);
+        if(nh==NULL){
+            nh=mrt_nexthop_add(group_rec, src_addr, MRT_DOWNSTREAM, src_seqno);
+        }
+        if(nh->activated){
+            mrt_nexthop_deactivate(group_rec, nh->addr);
+        }
+        if ( nh->direction==MRT_UPSTREAM) {
+            nh->direction=MRT_DOWNSTREAM;
+        }
+        mrt_nexthop_activate(group_rec, src_addr);
+        DEBUG(LOG_DEBUG, 0, "activated downstream %s", ip_to_str(src_addr));
+
+        /* check if we are not leader and yet have no upstream*/
+        if(!group_rec->am_leader && group_rec->activated_upstream_cnt==0) {
+            /* not leader and no upstream, so activate one */
+            mact_activate_best_upstream(group_rec);
+        }
+
+
+    }else if(mact->p) {
+        /* PRUNE */
+        mrt_nexthop_t *nexthop;
+        
+        DEBUG(LOG_DEBUG, 0, "Entered mact->p handler");
+       
+        nexthop=mrt_table_get_activated_upstream(group_rec);
+        if(nexthop!=NULL && nexthop->addr==src_addr){
+            DEBUG(LOG_DEBUG, 0, "\tUpstream sent prune");
+            /* deactivate said upstream in our records */
+            mrt_nexthop_deactivate(group_rec, nexthop->addr);
+            /* upstream sent us prune */
+            /* if member, become leader, else leave and make a downstream */
+            if(group_rec->is_member || (group_rec->is_gateway
+                        && group_rec->activated_downstream_cnt > 0)){
+                mrt_table_become_leader(group_rec);
+            }else{
+                mact_make_downstream_leader(group_rec);
+            }
+        }
+
+        /* if no other downstreams and not listening ourselves, prune self */
+        else if(!group_rec->is_member
+                && (!group_rec->is_gateway || group_rec->activated_upstream_cnt == 0)
+                && (group_rec->activated_downstream_cnt == 1)) {
+            mrt_nexthop_t *upstream;
+            /* Gateway code can create non-member leaders */
+            group_rec->is_gateway = 0;
+            group_rec->am_leader = 0;
+            upstream=mrt_table_get_activated_upstream(group_rec);
+            DEBUG(LOG_DEBUG, 0, "\tDownstream sent prune, prune self");
+            if(upstream != NULL){
+                mact_send(MACT_PRUNE, 1, grp_addr, upstream->addr,1);
+                mrt_nexthop_deactivate(group_rec, upstream->addr);
+            }
+            mrt_table_stop_routing(group_rec);
+        }else{
+            DEBUG(LOG_DEBUG, 0, "\tDownstream sent prune, stay on tree");
+        }
+
+        /* remove them */
+        mrt_nexthop_deactivate(group_rec, src_addr);
+    } else if(mact->g) {
+        /* GR/OUP LEADER
+         * 
+         * my upstream may send it to me.
+         * either I become leader or I promote a child
+         */
+
+        /* node who sent it has me marked as its upstream now */
+        mrt_nexthop_t *node;
+        node=mrt_table_get_activated_upstream(group_rec);
+        if(node!=NULL){
+            node->direction=MRT_DOWNSTREAM;
+            group_rec->activated_upstream_cnt--;
+            group_rec->activated_downstream_cnt++;
+        }
+        
+        if(group_rec->is_member) {
+            /* declare myself leader */
+            /* TODO: might need to set U flag on first one */
+
+            mrt_table_become_leader(group_rec);
+        } else {
+            /* send a notice to a downstream making it leader */
+            mact_make_downstream_leader(group_rec);
+        }
+    } else if(mact->u) {
+        /* UPDATE */
+    } else if(mact->r) {
+        /* REBOOT */
+    }
+}
+
+mrt_nexthop_t *mact_activate_best_upstream(mrt_table_t *mrt){
+    mrt_nexthop_t *besthop=NULL;
+
+    besthop=mrt_table_get_best_upstream(mrt);
+
+    /* and activate it */
+    if(besthop!=NULL){
+        mrt_table_start_routing(mrt);
+
+        mrt_nexthop_activate(mrt, besthop->addr);
+        mact_send(MACT_JOIN, 1, mrt->grp_addr, besthop->addr, 1);
+        DEBUG(LOG_DEBUG, 0, "activated upstream %s", ip_to_str(besthop->addr));
+
+        if ( seek_list_remove(seek_list_find(mrt->grp_addr) ) ) {
+            mcast_packet_queue_send( mrt->grp_addr );
+        }
+    }
+
+    return besthop;
+}
+
+void mact_make_downstream_leader(mrt_table_t *group_rec){
+    mrt_nexthop_t *downstream;
+    DEBUG(LOG_DEBUG, 0, "Entered mact_make_downstream_leader");
+    
+    if(group_rec->activated_downstream_cnt==0){
+        DEBUG(LOG_DEBUG, 0, "No downstreams to make leader!  Clearing flags");
+        mrt_table_stop_routing(group_rec);
+        group_rec->is_gateway = 0;
+        return;
+    }
+    
+    downstream=group_rec->nexthops;
+    while(downstream->direction!=MRT_DOWNSTREAM || !downstream->activated){
+        downstream=downstream->next;
+    }
+    
+    if(group_rec->activated_downstream_cnt==1){
+        /* one child, make him leader */
+        DEBUG(LOG_DEBUG, 0, "\tEntered one child version");
+        mact_send(MACT_PRUNE, 0, group_rec->grp_addr, downstream->addr,1);
+        mrt_nexthop_deactivate(group_rec, downstream->addr);
+        mrt_table_stop_routing(group_rec);
+
+        /* remove any pending RREQs (or other packets) for this group */
+        seek_list_remove(seek_list_find(group_rec->grp_addr));
+        packet_queue_drop(group_rec->grp_addr);
+
+        /* flush all nexthops */
+        mrt_nexthop_remove_all(group_rec);
+    }else{
+        /* send a 'G' mact to an arbitrary child, then make it upstream */
+        DEBUG(LOG_DEBUG, 0, "\tEntered many child version (where you stay as router)");
+        mact_send(MACT_GRPL, 0, group_rec->grp_addr, downstream->addr,1);
+        downstream->direction=MRT_UPSTREAM;
+        group_rec->activated_downstream_cnt--;
+        group_rec->activated_upstream_cnt++;
+    }
+}
+
+#endif /* MAODV */
diff -urNb aodv-uu-0.7.2/maodv_mact.h maodv-umd-0.7.2/maodv_mact.h
--- aodv-uu-0.7.2/maodv_mact.h	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/maodv_mact.h	Wed Jun 25 17:46:10 2003
@@ -0,0 +1,98 @@
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Dionysus Blazakis <dblaze@umd.edu>
+ *          Jonathan Polley <jpolley@umd.edu>
+ *          Dan Rusk <drusk@umd.edu>
+ *          Manish Karir <karir@umd.edu>
+ *
+ *****************************************************************************/
+
+#ifndef MAODV_MACT_H
+#define MAODV_MACT_H
+
+#ifndef NS_NO_GLOBALS
+#include <endian.h>
+
+#include "defs.h"
+#include "multicast_routing_table.h"
+
+/* MACT Flags: */
+#define MACT_JOIN   0x10
+#define MACT_PRUNE  0x08
+#define MACT_GRPL   0x04
+#define MACT_UPDATE 0x02
+#define MACT_REBOOT 0x01
+
+typedef struct _mact_t {
+    u_int8_t type;
+#  if __BYTE_ORDER == __LITTLE_ENDIAN
+    u_int8_t res1:3;
+    u_int8_t r:1;
+    u_int8_t u:1;
+    u_int8_t g:1;
+    u_int8_t p:1;
+    u_int8_t j:1;
+#  elif __BYTE_ORDER == __BIG_ENDIAN
+    u_int8_t j:1;
+    u_int8_t p:1;
+    u_int8_t g:1;
+    u_int8_t u:1;
+    u_int8_t r:1;
+    u_int8_t res1:3;
+#  else
+#   error "Adjust your <bits/endian.h> defines"
+#  endif
+    u_int8_t res2;
+    u_int8_t hcnt;
+    u_int32_t grp_addr;
+    u_int32_t src_addr;
+    u_int32_t src_seqno;
+} mact_t;
+
+#define MACT mact_t
+#define MACT_SIZE sizeof(MACT)
+
+#endif				/* NS_NO_GLOBALS */
+
+#ifndef NS_NO_DECLARATIONS
+MACT *mact_create(u_int8_t flags,
+        u_int8_t hcnt,
+        u_int32_t src_addr,
+        u_int32_t grp_addr);
+
+void mact_send(u_int8_t flags,
+        u_int8_t hcnt,
+        u_int32_t grp_addr,
+        u_int32_t dst_addr,
+        int ttl);
+
+void mact_mcast(u_int8_t flags,
+        u_int8_t hcnt,
+        u_int32_t grp_addr,
+        int ttl);
+
+void mact_process(MACT *mact);
+
+mrt_nexthop_t *mact_activate_best_upstream(mrt_table_t *mrt);
+void mact_make_downstream_leader(mrt_table_t *mrt);
+
+
+#endif				/* NS_NO_DECLARATIONS */
+
+#endif				/* MAODV_MACT_H */
diff -urNb aodv-uu-0.7.2/maodv_neighbor.c maodv-umd-0.7.2/maodv_neighbor.c
--- aodv-uu-0.7.2/maodv_neighbor.c	Wed Dec 31 19:00:00 1969
+++ maodv-umd-0.7.2/maodv_neighbor.c	Wed Jun 25 17:46:09 2003
@@ -0,0 +1,108 @@
+#ifdef MAODV
+
+/*****************************************************************************
+ *
+ * Copyright (C) 2003 CSHCN, University of Maryland.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Dionysus Blazakis <dblaze@umd.edu>
+ *          Jonathan Polley <jpolley@umd.edu>
+ *          Dan Rusk <drusk@umd.edu>
+ *          Manish Karir <karir@umd.edu>
+ *          Jonathan McGee <mcgee@umd.edu>
+ *
+ *****************************************************************************/
+
+#include "maodv_neighbor.h"
+#include "routing_table.h"
+#include "multicast_routing_table.h"
+#include "aodv_rreq.h"
+#include "maodv_mact.h"
+#include "debug.h"
+#include "params.h"
+
+void mcast_neighbor_link_break(rt_table_t *rt){
+    mrt_table_t *mrt;
+    mrt_nexthop_t *nexthop;
+    int i;
+    
+    /* determine which, if any, groups the broken node is in */
+    for(i=0; i<MRT_TABLESIZE; i++){
+        mrt=mrt_tbl.tbl[i];
+
+        while(mrt!=NULL){
+            nexthop=mrt_nexthop_find(mrt, rt->dest_addr);
+
+            /* only care about activated routes */
+            if(nexthop!=NULL && nexthop->activated){
+                int nh_dir=nexthop->direction;
+
+                mrt_nexthop_remove(mrt, nexthop->addr);
+                if(nh_dir==MRT_UPSTREAM){
+                    mrt->is_broken = 1;
+
+                    /* we lost our upstream, find a new one */
+                    rreq_route_discovery(mrt->grp_addr, 
+                        RREQ_JOIN|RREQ_GRP_REBUILD, NULL, 0);
+                }else{
+                    /* we lost our downstream, wait to see if he returns */
+                    mrt_nexthop_remove(mrt, nexthop->addr);
+
+                    if(!mrt->is_member && mrt->activated_downstream_cnt==0){
+                        DEBUG(LOG_DEBUG, 0, "setting prune dangle timer");
+
+                        /* set timeout to prune self if downstream doesn't
+                         * reconnect */
+                        mrt->prune_timer.handler = (timeout_func_t) &mcast_prune_dangle;
+                        mrt->prune_timer.data = &mrt;
+
+                        /* 20 seconds of rebuild time. */
+                        timer_set_timeout( &mrt->prune_timer, PRUNE_TIMEOUT );
+                    }
+                }
+            }else if(nexthop!=NULL && !nexthop->activated){
+                mrt_nexthop_remove(mrt, nexthop->addr);
+            }
+            
+            mrt=mrt->next;
+        }
+    }
+}
+
+/* mcast_prune_dangle
+ * if you become a router only with no downstream nodes, (dangling) then
+ * prune self after a timeout */
+void mcast_prune_dangle( mrt_table_t *mrt ) {
+    mrt_nexthop_t * upstream;
+
+    DEBUG(LOG_DEBUG, 0, "in prune dangle timer");
+    if ( mrt->activated_downstream_cnt == 0 && !mrt->is_member 
+            && (!mrt->is_gateway || (mrt->activated_upstream_cnt == 0))) {
+        /* prune me */
+
+        upstream = mrt_table_get_activated_upstream( mrt ); 
+        DEBUG( LOG_DEBUG, 0, "Pruning myself after a reasonable timeout." );
+
+        if(upstream != NULL){
+            mact_send( MACT_PRUNE, 1, mrt->grp_addr, upstream->addr, 1 );
+            mrt_nexthop_deactivate( mrt, upstream->addr );
+        }
+
+        mrt_table_stop_routing(mrt);
+    }
+}
+
+#endif
